//*****************************************************************//
//                                                                 //
//  MIME Base64 Encoding Demo Application                          //
//  Copyright BrandsPatch LLC                                     //
//  http://www.explainth.at                                        //
//                                                                 //
//  All Rights Reserved                                            //
//                                                                 //
//  Permission is granted to use, modify and redistribute          //
//  the code in this Delphi unit on the condition that this        //
//  notice is retained unchanged.                                  //
//                                                                 //
//                                                                 //
//  BrandsPatch declines all responsibility for any losses,        //
//  direct or indirect, that may arise  as a result of using       //
//  this code.                                                     //
//                                                                 //
//*****************************************************************//
unit Main;

interface

uses Windows,Messages,SysUtils,Variants,Classes,Graphics,Controls,Forms,
     Dialogs,StdCtrls,ComCtrls;

type TMaster = class(TForm)
  pgcDemo:TPageControl;
  tsReadMe:TTabSheet;
  redReadMe:TRichEdit;
  tsDemo:TTabSheet;
  lblInput:TLabel;
  memoIn:TMemo;
  btnEncode:TButton;
  btnDecode:TButton;
  procedure FormCreate(Sender:TObject);
  procedure FormCloseQuery(Sender:TObject;var CanClose:Boolean);
  procedure DoEncode(Sender:TObject);
  procedure DoDecode(Sender:TObject);
private
public
end;

var Master:TMaster;

implementation

{$R *.dfm}
{$R WindowsXP.RES}

uses Mime;

procedure TMaster.FormCreate(Sender:TObject);
var AFile:String;
begin
  AFile:=Format('%sReadMe.RTF',[ExtractFilePath(Application.ExeName)]);
  if FileExists(AFile) then redReadMe.Lines.LoadFromFile(AFile);
end;

const _Prompt = 'Did you find this code useful?'#13'If so, please help us by creating links to our site, www.explainth.at';

procedure TMaster.FormCloseQuery(Sender:TObject;var CanClose:Boolean);
begin
  MessageDlg(_Prompt,mtInformation,[mbOK],0);
end;

procedure TMaster.DoEncode(Sender:TObject);
var i,ALen:Integer;
    AWord:Word;
    AIn:String;
begin
  AIn:=memoIn.Lines.Text;
  ALen:=Length(AIn);

  if (ALen = 0) then
  begin
    MessageDlg('Nothing to do!',mtError,[mbOK],0);
    exit;
  end;

  i:=Pos(#13#10,AIn);
  if ((i > 0) and (i = ALen - 1)) then
  begin
    Delete(AIn,ALen - 1,2);
    dec(ALen,2);//remove terminating CRLF added by memo control
  end;

  with TMemoryStream.Create do
  try
    WriteBuffer(AIn[1],ALen);
    WriteBuffer(AWord,sizeof(AWord));
    {write two extra bytes so the memory block is
     large enough to accomodate any padding bytes}
    memoIn.Lines.Text:=MimeEncode(Memory,ALen);
  finally Free end;
end;

procedure TMaster.DoDecode(Sender:TObject);
var i,ADiscard,ALen:Integer;
    ACode:String;
    AStream:TStream;
begin
  ACode:=memoIn.Lines.Text;
  ALen:=Length(ACode);
  if (ALen = 0) then
  begin
    MessageDlg('Nothing to do',mtError,[mbOK],0);
    exit;
  end;

  i:=Pos(#13#10,ACode);
  if ((i > 0) and (i = ALen - 1)) then Delete(ACode,ALen - 1,2);
  //remove terminating CRLF added by memo control
  AStream:=MimeDeCode(ACode,ADiscard);
  try memoIn.Lines.LoadFromStream(AStream) finally AStream.Free end;
end;

end.

